# coding: utf-8

import datetime

from django.conf import settings
from django.core.management.base import BaseCommand

from acomea.tracerequest.models import TraceRequestData

from optparse import make_option


class Command(BaseCommand):
    """
    Removes all pending data after a setting duration period
    """
    output_transaction = True

    def handle(self, *args, **options):
        max_days_token_duration = settings.TRACEREQUEST_TOKEN_DAYS_DURATION
        for trace_request in TraceRequestData.objects.all():
            days_delta = (datetime.datetime.now() - trace_request.date_last_modify).days
            if days_delta > max_days_token_duration:
                trace_request.delete()
