// MANUAL LOGIN/REGISTRATION
function manualLoginG5() {
    clearErrors;
    $.post(
        "{{ settings.proxy_pass_url }}api/login.json",
        {password: $('#id_password').val(), userid: $('#id_email').val(), appName: 'G5APIWebLandingV3'}
    )
    .done(function(data) {
        loginG5(data.token);
    })
    .fail(function(error) {
        $('#msg-error').html('Utente/Password non validi');
        $('#myModal').modal('show')
    });
}

function manualRegistrationG5() {
    clearErrors();
    var hash = md5($('#id_email').val()+ '_' +  $('#id_password').val() + '_sg1mm3s')
    $.post(
        "{{ settings.proxy_pass_url }}api/registration-manual.json",
        {
            'privacy': $('input[name="auth_trattamento_dati"]:checked').val(),
            'user.firstName': $('#id_first_name').val(),
            'user.lastName': $('#id_last_name').val(),
            'user.email': $('#id_email').val(),
            'user.password': $('#id_password').val(),
            'secretKey': hash,
            'appName': 'G5APIWebLandingV3'
        }
    )
    .done(function(data) {
        window.location.href='{{ settings.registration_thanks_url }}';
    })
    .fail(function(error) {
        for(field in error.responseJSON){
            var pop=inputs[field].popover({placement:'bottom', trigger:'focus'});
            pop.attr('data-content', error.responseJSON[field]).data('bs.popover').show();
        }
    });
}

// FACEBOOK
function fbLogin() {
    FB.login(function (response) {
        if (response.authResponse) {
            // Get and display the user profile data
            loginG5Facebook()
        } else {
            document.getElementById('status').innerHTML = 'User cancelled login or did not fully authorize.';
        }
    }, {scope: 'email'});
}

<!-- FACEBOOK -->
  // This is called with the results from from FB.getLoginStatus().
    function statusChangeCallback(response) {
        if (response.status === 'connected') {
          // Logged into your app and Facebook.
            loginG5Facebook();
        } else {
          // The person is not logged into your app or we are unable to tell.
            document.getElementById('status').innerHTML = 'Please log ' + 'into this app.';
        }
    }

  // This function is called when someone finishes with the Login
  // Button.  See the onlogin handler attached to it in the sample
  // code below.
    function checkLoginState() {
        FB.getLoginStatus(function(response) {
            statusChangeCallback(response);
        });
    }

    window.fbAsyncInit = function() {
        FB.init({
            appId      : '{{ settings.facebook_app_id }}',
            cookie     : true,  // enable cookies to allow the server to access the session
            xfbml      : true,  // parse social plugins on this page
            version    : 'v2.8' // use graph api version 2.8
        });
    };

    // Load the SDK asynchronously
    (function(d, s, id) {
        var js, fjs = d.getElementsByTagName(s)[0];
        if (d.getElementById(id)) return;
        js = d.createElement(s); js.id = id;
        js.src = "//connect.facebook.net/en_US/sdk.js";
        fjs.parentNode.insertBefore(js, fjs);
    }(document, 'script', 'facebook-jssdk'));

  // Here we run a very simple test of the Graph API after login is
  // successful.  See statusChangeCallback() for when this call is made.
    function loginG5Facebook() {
        FB.api('/me',
            {fields: 'id,first_name,last_name,picture,email'},
            function(response) {
                var hash = md5(response.id + '_facebook_sg1mm3s')

                data = {
                    'user.firstName': response.first_name,
                    'user.lastName': response.last_name,
                    'user.email': response.email,
                    'user.userID': response.id,
                    'avatar': response.picture,
                    'socialSubscription': 'facebook',
                    'secretKey': hash,
                    'appName': 'gimme5',
                }
                gimme5Socialregistration(data);
            }
        );
    }


// GPLUS
var googleUser = {};
var startApp = function() {
gapi.load('auth2', function(){
  // Retrieve the singleton for the GoogleAuth library and set up the client.
  auth2 = gapi.auth2.init({
    client_id: '{{ settings.google_app_id }}.apps.googleusercontent.com',
    cookiepolicy: 'single_host_origin',
    // Request scopes in addition to 'profile' and 'email'
    //scope: 'additional_scope'
  });
  attachSignin(document.getElementById('gplus-custom-btn'));
});
};

function attachSignin(element) {
console.log(element.id);
auth2.attachClickHandler(element, {}, loginG5Google);
}

startApp();

function loginG5Google(googleUser) {
    var profile = googleUser.getBasicProfile();
    var hash = md5(profile.Eea + '_gplus_sg1mm3s')

    data = {
        'user.firstName': profile.ofa,
        'user.lastName': profile.wea,
        'user.email': profile.U3,
        'user.userID': profile.Eea,
        'avatar': profile.Paa,
        'socialSubscription': 'gplus',
        'secretKey': hash,
        'appName': 'gimme5',
    }
    // prevent autologin at sencond time
    gapi.auth2.getAuthInstance().signOut().then(function () {
        console.log('User signed out.');
    });
    gimme5Socialregistration(data);
}


// INIT
$(document).ready(function () {
    // GENERIC FUNCTION
    gimme5Socialregistration = function (data){
        clearErrors();
        $.post(
            "{{ settings.proxy_pass_url }}api/registration.json",
            data
        )
        .done(function(data) {
            loginG5(data.token);
        })
        .fail(function(error) {
            if(error.status==303){
                loginG5(error.responseJSON.token);
            }else{
                $('#msg-error').html('Questa mail è già associata ad un altro account');
                $('#myModal').modal('show')
            }
        });
    }

    function loginG5(token){
        showSpinner();
        $.post(
            "{{ settings.proxy_pass_url }}json/getUserInfo.action",
            {token: token}
        )
        .done(function(data) {
            window.location.href='{{ settings.activation_thanks_url }}';
        })
        .fail(function(error) {
            $('.non_field_error').find('span').html(error.statusText);
            $('.non_field_error').show();
        });
    }
 })

 // INIZIALIZZAZIONE PER ASYNC
var gimme5Socialregistration;

var inputs = {
    'user.firstName': $('#id_first_name'),
    'user.lastName': $('#id_last_name'),
    'user.email': $('#id_email'),
    'user.password': $('#id_password'),
    'privacy': $('input[name="auth_trattamento_dati"]')
}

var clearErrors = function(){
    $('.popover').popover('hide');
}

$("input").not(':input[type=submit]').attr('required', true)


// SPINNER
function showSpinner() {
    $.blockUI({ message: '<div class="spinner"><div class="bounce1"></div><div class="bounce2"></div><div class="bounce3"></div></div>',
     css: { backgroundColor: 'transparent', borderColor: 'transparent' },
     overlayCSS: { opacity: 0.4}
    });
};

$(document).ajaxStart(showSpinner).ajaxStop($.unblockUI);
